///////////////////////////////////////////////////////////////////////////
// copyleft 2008
// This file is part of IP Banner addon for Brazil Firewall.
//
// IP Banner is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3, or (at your option)
// any later version.
//
// IP Banner is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// www.gnu.org
//
// Daniel Torres (Cavernicola)
// Mexicali, Baja California, Mexico, Junio 2008
// thecavernicola@gmail.com
//////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <set>
#include <sys/stat.h>
#include "cutter.h"
using namespace std;


///Variables
const char* SCRIPT = "ipbanner.cgi";
const char* EXEC_WF = "/var/http/execWF.sh";
const char* COYOTE_CONF = "/etc/coyote/coyote.conf";
string Lenguaje = "'ENU'"; //"'ENU'"; // 'ESP', 'BRZ'
const char* BANNED_PATH = "/tmp/banned.dat";
const char* BANNED_TEMP_PATH = "/tmp/banned.temp2";
const char* IP_CONNTRACK_PATH = "/proc/net/ip_conntrack";
void InitVariables();

void showMainControls();
const char* ShowMSG(char code);
void WhosConnected();
void cl_header2();
void cl_footer2();
void show( string s );
string GetSubstring(string s, const char* beg, const char* end);
string GetIPFromIPCONNTRACKFileLine(string line);
string GetIPFromBannedIPFileLine(string line);
void ProcessGet();
void ProcessPost();
void ShowBannedList();
void ListBannedIPs();
string GetButtonAction(char* buffer);
void KickOut( char* buffer );
void UnKickOut( char* buffer );
string GetIpToKick(char* cbuffer);
int GetMinutosBanned(const char* cbuffer);
void SetBannedIpData(string IP, int timeToUnBan);
void RemoveBannedIpData(string IP);
void ActualizeBannedIpData(string IP, int timeToUnBan);
int GetTimeBanned(string buffer);
int GetLeftBanningMinutes(int BannedTime);
string GetIpToKickFromListOfBanned(char* cbuffer);

int main()
{
    InitVariables();

    char* rqmt = getenv("REQUEST_METHOD");

    if( rqmt == NULL) return 0;

    if(memcmp( "GET", rqmt, 3) == 0) ProcessGet();

    else if(memcmp( "POST", rqmt, 4 ) == 0) ProcessPost();

    return 0;
}

void InitVariables()
{
    ifstream file ( COYOTE_CONF, ifstream::in);
    string line = "";
    uint index1 = 0;

    while(getline(file, line))
    {

        index1 = line.find("LANGUAGE_WEBADMIN=");

        if(index1 != string::npos)
        {
            line = line.substr( index1 + (sizeof("LANGUAGE_WEBADMIN=") - 1));
            Lenguaje = line;
            continue;
       }
    }

    file.close();
}

void ProcessGet()
{
    cl_header2();

	register char* raw_get = getenv("QUERY_STRING");

	if (raw_get==NULL)
	{
        showMainControls();
        return;
	}

    if( memcmp( "ListOfBannedIPS", raw_get, 15 ) == 0 )  ShowBannedList();

    cl_footer2();
}

void ShowBannedList()
{
   cout << "<form action=" << SCRIPT << " method=\"post\">"
         <<     "<table class=maintable width=100% border=\"0\">"
         <<         "<tr>"
         <<             "<td class=row6 >"//colspan=\"2\" >"
         <<                ShowMSG(4) << "<input style=\"text-align: center;\" maxlength=\"3\" size=\"3\" name=\"minBanned\" /> min.<br />"// <<  ZeroMinForUndefined
         <<                ShowMSG(5) << "<br />"
         <<                ShowMSG(6) << "<input  name=\"ClearBanning\" type=\"checkbox\" />"// <<  ZeroMinForUndefined
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr align=\"center\">"
         <<             "<td>"
         <<                 "<select multiple=\"multiple\" size=\"10\" name=\"IpToKick\">";

    ListBannedIPs();

    cout <<                 "</select>"
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr>"
         <<             "<td class=row2 align=center >"
         <<                 "<input name=\"btnAction\" value=\""<< ShowMSG(10) << "\" type=\"submit\" />"
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr align=\"center\">"
         <<             "<td><a href=\"" << SCRIPT << "?ListOfBannedIPS\">" << ShowMSG(2) << "</a></td>"
         <<         "</tr>"
         <<     "</table>"
         << "</form>" << endl;

 /*   cout << "<table class=maintable width=25% border=\"0\">"
         <<    "<tr align=center>"
         <<        "<td>"
         <<            "&nbsp;&nbsp;<a href=\""<< SCRIPT << "?help\">Help</a>"
         <<        "</td>"
         <<    "</tr>"
         << "</table>";*/

         cl_footer2();
}

void ListBannedIPs()
{
    ifstream ifs (BANNED_PATH,ifstream::in);
    string line = "";
    string IP;
    int MinutesBannedLeft;

    while (getline(ifs, line))
    {
	IP = GetIPFromBannedIPFileLine(line);
	MinutesBannedLeft = GetLeftBanningMinutes(GetTimeBanned(line));

        cout << "<option>" << IP << ShowMSG(12) << MinutesBannedLeft << "</option>";
    }
}

void ProcessPost()
{
	if ( getenv("CONTENT_LENGTH") )
	{
        int content_length;

	    char *buffer = NULL;

	    content_length = atoi( getenv("CONTENT_LENGTH") );

        buffer = new char[content_length*sizeof(char)];

        cin.read( buffer, content_length);

        if(GetButtonAction(buffer).find("Ban") != string::npos)
            KickOut(buffer);
        else
            UnKickOut(buffer);

        delete buffer;

        buffer = NULL;
	}
}

void show( int s )
{
    cl_header2();
    cout << s;
    cl_footer2();
    exit(0);
}

void KickOut( char* buffer )
{
    string IP = GetIpToKick(buffer);

    if(IP == "NO_IP")
        ShowMSG(7);

    int min = GetMinutosBanned(buffer);

    CutIt(IP.c_str());

    if(min != -1)
    	SetBannedIpData( IP, min );
    else
	UnCutIt(IP.c_str());	

    ShowMSG(8);
}

void SetBannedIpData(string IP, int timeToUnBan)
{
    time_t raw;

    time(&raw);

    if( timeToUnBan > 0 )
    {
        timeToUnBan = timeToUnBan * 60; //Lo convertimos a segundos
	//show(timeToUnBan);
        timeToUnBan += raw;
    }

    ofstream ofs(BANNED_PATH, ios::out|ios::app);

    ofs << IP << ":" << timeToUnBan << endl;

    ofs.close();
}

string GetIpToKick(char* cbuffer)
{
    string buffer = cbuffer;

    string IP = "";

    uint beg = buffer.find("IpToKick=");

    if( beg == string::npos )
        return "NO_IP";

    beg += sizeof("IpToKick");

    uint end = buffer.find("&", beg);

    buffer = buffer.substr(beg, end - beg);

    return buffer;
}

string GetIpToKickFromListOfBanned(char* cbuffer)
{
    string buffer = cbuffer;

    string IP = "";

    uint beg = buffer.find("IpToKick=");

    if( beg == string::npos )
        return "NO_IP";

    beg += sizeof("IpToKick");

    uint end = buffer.find("+");

    buffer = buffer.substr(beg, end - beg);

    return buffer;
}

int GetMinutosBanned(const char* cbuffer)
{
    //DoNotPermitNewConecctions=no&minBanned=100&IpToKick=192.168.0.105&btnAction=Patear
    string buffer = cbuffer;

    uint beg = buffer.find("minBanned=");

    beg += sizeof("minBanned");

    uint end = buffer.find('&');

    buffer = buffer.substr(beg, end - beg);
	   
    if(  buffer == "" )
        return -1;

    for(int i =0; i < buffer.size(); i++) 
        if(isdigit(buffer[i]) == 0)
	    ShowMSG(11);

    return atoi( buffer.c_str() );
}

void UnKickOut( char* buffer )
{
    string IP = GetIpToKickFromListOfBanned(buffer);

    string sbuffer = buffer;

    if(IP == "NO_IP")
        ShowMSG(7);

    if(sbuffer.find("ClearBanning") != string::npos)
    {
        RemoveBannedIpData( IP );

        UnCutIt(IP.c_str());
    }
    else
    {
	ActualizeBannedIpData(IP, GetMinutosBanned(buffer));
    }

    ShowMSG(8);
}

void ActualizeBannedIpData(string IP, int timeToUnBan)
{
    time_t raw;

    time(&raw);

    if( timeToUnBan > 0 )
    {
        timeToUnBan = timeToUnBan * 60; //Lo convertimos a segundos

        timeToUnBan += raw;
    }

    ifstream ifs(BANNED_PATH, ios::in);

    ofstream ofs(BANNED_TEMP_PATH, ios::out);

    string line;

    while (getline(ifs, line))
    {
        if( line.find(IP) == string::npos )
            ofs << GetIPFromBannedIPFileLine(line) << ":" << GetTimeBanned(line) << endl;
        else
            ofs << IP << ":" << timeToUnBan << endl;
    }


    line = "mv -f ";
    line += BANNED_TEMP_PATH;
    line += " ";
    line += BANNED_PATH;

    system( line.c_str() );

    ifs.close();

    ofs.close();
}


int GetLeftBanningMinutes(int BannedTime)
{
    int currentTime;
    time((time_t*)&currentTime);

    return (1 + (BannedTime - currentTime) / 60);
}

int GetTimeBanned(string buffer)
{
    return atoi(buffer.substr( buffer.find(':') + 1, buffer.size() ).c_str());//atoi(Time.c_str());
}

void RemoveBannedIpData(string IP)
{
    ifstream ifs(BANNED_PATH, ios::in);

    ofstream ofs(BANNED_TEMP_PATH, ios::out);

    string line;

    while (getline(ifs, line))
    {
        if( line.find(IP) == string::npos )
            ofs << GetIPFromBannedIPFileLine(line) << ":" << GetTimeBanned(line) << endl;
    }

    line = "mv -f ";
    line += BANNED_TEMP_PATH;
    line += " ";
    line += BANNED_PATH;

    system( line.c_str() );

    ifs.close();

    ofs.close();
}

string GetButtonAction(char* buffer)
{
    //minBanned=asa&IpToKick=192.168.0.103&btnAction=KickOut

    string sbuffer = buffer;

    return  sbuffer.substr( sbuffer.find("btnAction=") + sizeof("btnAction"), sbuffer.size());//atoi(Time.c_str());

}

void showMainControls()
{
    cout << "<form action=" << SCRIPT << " method=\"post\">"
         <<     "<table class=maintable width=100% border=\"0\">"
         <<         "<th colspan=\"2\">IP Banner 0.2</th>"
         <<         "<tr>"
         <<             "<td class=row6 >"//colspan=\"2\" >"
         <<                ShowMSG(1) << "<input style=\"text-align: center;\" maxlength=\"3\" size=\"3\" name=\"minBanned\" /> min. "// <<  ZeroMinForUndefined
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr align=\"center\">"
         <<             "<td>"
         <<                 "<select multiple=\"multiple\" size=\"10\" name=\"IpToKick\">";

    WhosConnected();

    cout <<                 "</select>"
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr>"
         <<             "<td class=row2 align=center >"
         <<                 "<input name=\"btnAction\" value=\""<< ShowMSG(9) << "\" type=\"submit\" />"
         <<             "</td>"
         <<         "</tr>"
         <<         "<tr align=\"center\">"
         <<             "<td><a href=\"" << SCRIPT << "?ListOfBannedIPS\">" << ShowMSG(2) << "</a></td>"
         <<         "</tr>"
         <<     "</table>"
         << "</form>" << endl;

/*    cout << "<table class=maintable width=25% border=\"0\">"
         <<    "<tr align=center>"
         <<        "<td>"
         <<            "&nbsp;&nbsp;<a href=\""<< SCRIPT << "?help\">Help</a>"
         <<        "</td>"
         <<    "</tr>"
         << "</table>";*/

         cl_footer2();
}

const char* ShowMSG( char code )
{
    switch( code )
    {
        case 1: // Select file to upload
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "No permitir nuevas conexiones de esta IP por los proximos: <br />Escriba 0 para indefinido";

                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "Não permitir que novas conexões para este IP para os próximos: <br /> Escreva 0 para indefinido ";

            return "Do not permit new conecctions from this IP for the next: <br /> Write 0 for indefinite ";

            break;
        }
        case 2: // Button Upload
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Lista de IPs baneadas";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "lista de IPs proibido";

            return "List of Banned IPs";

            break;
        }
        case 3: // Path de destino
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Ayuda";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return "Ajuda";
                    else return "Help";

            break;
        }
        case 4:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Reducir o aumentar el tiempo de prohibicion a: ";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return " Aumente ou reduza o tempo de proibição: ";
                    else return "Increase or reduce the banning time to: ";

            break;
        }
        case 5:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "O";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return "Ou";

            return "Or";
	    break;
        }
        case 6:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Retirar la prohibicion a la IP seleccionada";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return "Cancele o probition ao IP selecionado";

            return "Clear the banning of the selected ip";
	    break;
        }
        case 7:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) show( "Debe seleccionar una IP de la lista" );
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) show( "Deve selecionar um IP da lista" );

            show( "Must select an IP from the list" );
	    break;
        }
        case 8:
        {
            cl_header2();
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) cout<< "Los cambios fueron establecidos con exito";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) cout << "As mudanças foram estabelecidas com sucesso" ;
                     else cout << "The changes were established successfully";
            cl_footer2();
	    break;
        } 
        case 9:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Banear";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return "Banir";

            return "Ban";
	    break;
        }
        case 10:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Modificar";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return "Modificar";

            return "Modify";
	    break;
        }   
        case 11:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) show("Error en uno de los valores");
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) show("Erro em um dos valores") ;

            show("Some of the values are wrong");
            break;
        }    //
        case 12:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return " - minutos restantes de la prohibicion: ";
                else if( memcmp( "'POR'", Lenguaje.c_str(), 5 ) == 0 ) return " - minutos de interdição remanescentes: ";

            return " - minutes of banning remaining: ";
            break;
        }    //10 minutes of banning remaining
   
    }

    return "";
}

void WhosConnected()
{
    ifstream ifs (BANNED_PATH,ifstream::in);
    string line = "";

    set<string> BanedIps;

    while (getline(ifs, line))
    {
        BanedIps.insert(GetIPFromBannedIPFileLine(line));
    }

    ifstream file (IP_CONNTRACK_PATH,ifstream::in);
    uint i = 0;
    set<string> IPS;

    while(getline(file, line))
    {
        line = GetIPFromIPCONNTRACKFileLine(line);
        if( IPS.find(line) == IPS.end() && BanedIps.find(line) == BanedIps.end())
        {
            IPS.insert(line);
            cout << "<option>" << line << "</option>";
        }

        i++;
    }
    file.close();
}

void cl_header2()
{
    string s = " cl_header2 IP-Banner";
    s.insert(0, EXEC_WF);
    system(s.c_str());
}

void cl_footer2()
{
  struct stat stFileInfo;

  cout << "</td></tr></table></td></tr></table>"
       << ( stat( "/tmp/need.save" ,&stFileInfo) == 0 ? "<br><center><div id=warning>WARNING: Configuration has been changed but not yet backed up.</div></center>" : "")
       << ( stat( "/tmp/need.reboot" ,&stFileInfo) == 0 ? "<br><center><div id=warning>WARNING: Configuration has been backed up but system not yet rebooted.</div></center>" : "");
       //Wta="WARNING: Configuration has been changed but not yet backed up."
       //Wtb="WARNING: Configuration has been backed up but system not yet rebooted."*/LANGUAGE_CODE="ESP"

}

void show( string s )
{
    cl_header2();
    cout << s;
    cl_footer2();
    exit(0);
}

string GetSubstring(string s, const char* beg, const char* end)
{
    uint ind1 = s.find(beg);

    if( ind1 == string::npos)
        return "";

    uint ind2 = s.find(end);

    if( ind2 == string::npos)
        return "";

    return s.substr(ind1 + sizeof(beg), ind2 - ind1 - sizeof(end));;
}

string GetIPFromIPCONNTRACKFileLine(string line)
{
     return GetSubstring(line, "src=", " dst=");
}

string GetIPFromBannedIPFileLine(string line)
{
    return line.substr(0, line.find(':'));
}

