///////////////////////////////////////////////////////////////////////////
// copyleft 2008
// This file is part of IP Banner addon for Brazil Firewall.
//
// IP Banner is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3, or (at your option)
// any later version.
//
// IP Banner is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// www.gnu.org
//
// Daniel Torres (Cavernicola)
// Mexicali, Baja California, Mexico, Junio 2008
// thecavernicola@gmail.com
//////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <string>
#include <time.h>

using namespace std;
const char* PATH = "/tmp/banned.dat";
const char* PATH_TEMP = "/tmp/banned.temp1";
string GetIP(string line)
{
    return line.substr(0, line.find(':'));;
}

int GetTimeBanned(string buffer)
{
    return atoi(buffer.substr( buffer.find(':') + 1, buffer.size() ).c_str());//atoi(Time.c_str());
}

void UnBan( string IP )
{
    std::string iptablesRule = "/usr/sbin/iptables -D FORWARD -s ";// + IP + " -j REJECT";
    iptablesRule += IP;
    iptablesRule += " -j REJECT";
    system( iptablesRule.c_str() );
}

int main()
{
    string line;
    time_t now;
    bool replace = false;

    while ( true )
    {
        ifstream ifs(PATH, ios::in);

        ofstream ofs(PATH_TEMP, ios::out);

        replace = false;

        time(&now);

        while (getline(ifs, line))
        {
            int n = GetTimeBanned(line);
	    if(n == 0)
		continue;

            if( now > n )
            {
                UnBan(GetIP(line));
                replace = true;
            }
            else
                ofs << GetIP(line) << ":" << GetTimeBanned(line) << endl;
        }

        line = "mv -f ";
        line += PATH_TEMP;
        line += " ";
        line += PATH;

        if( replace )
            system( line.c_str() );

        ifs.close();

        ofs.close();

        line = "";

        sleep(5);
    }

    return 0;
}
